#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include "jtypes.h"
#include "softbank.h"
#include "palfile.h"
#include "vidmode.h"
#include "genpal.h"

#define PALETTE_LEN    64 

static i8   *usage =
    ".spr viewer\nusage:  %s [filename] <HSIPalFile>\n";

static u8   pal[768];


/*

%% .................................................................. */
int main (
    int argc,
    char *argv[]
    )
{
    u32         palLEN = 0;
    SoftBank    *sb0;

    u8  *screen;
    u8  *dst;
    u32 u0,u1,u2,u3;
    u32 col;

    if ((argc < 2) || (argc > 3)) {
        printf(usage,argv[0]);
        return 1;
    }
    if (argc == 3) {
        HSIPalFile userDefined;
        u0 = userDefined.load(argv[2]);
        if (u0) return 1;
        palLEN = userDefined.paletteLen();
        userDefined.copyPalette18bit(pal,0,palLEN);
    }
    if (argc == 2) {
        palLEN = PALETTE_LEN;
        genPalette((i8*) pal,(i32) palLEN);
    }

    sb0 = new SoftBank(argv[1]);
    openGraphics(&screen);
    setpalvec(pal,0,(palLEN - 1));
    dst = screen;

    u1 = sb0->spriteQty();
    col = 0;
    char cmd = 0;
    u0 = 0;

    while (cmd != 'q') {
        sb0->blt8bpp(dst,320,u0);
        cmd = getchar();
        u2 = sb0->spriteWd(u0);
        u3 = 0;
	switch (cmd) {
	case 'p':
	    u0 = (u0 == 0) ? 0 : (u0 - 1);
	    u3 = sb0->spriteWd(u0);
	    break;
	case 'n':
	    u0 = (u0 < (u1 - 1)) ? (u0 + 1) : u0;
	    u3 = sb0->spriteWd(u0);
	    break;
	default:
	    u0 = (u0 < (u1 - 1)) ? (u0 + 1) : u0;
	    u3 = sb0->spriteWd(u0);
	    break;
	}
        col += u2;
        if ((319-col) >= u3) {
            dst += u2;
        }
        else {
            dst = screen;
            col = 0;
            memset(screen,0,64000);
        }
    }

    delete sb0;
    closeGraphics();
    return 0;
}

