/*                                                        .    .
   TA Davis Chen                                     .           John Beppu
   Section 3                                                       05122860
                                                 .           __ _    ICS 80
   I'm in a hurry, so this will be a poor                   / _(_)_   _____
   implementation.  Only the minimum will                  | |_| \ \ / / _ \
   be implemented.                                         |  _| |\ ` /  __/
                                               .           |_| |_| \_/ \___|

%% 1234512345123451234512345123451234512345123451234512345123451234512345 */

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

#define coder       JBeppu
#define VERSION     0.80
#define NotSilent   0

#define xx_ACCESS   0
#define Rx_ACCESS   1
#define xW_ACCESS   2
#define RW_ACCESS   3

#define EOLN_UNIX   0
#define EOLN_DOS    1
#define ALLOC_STEP  32          // Please let this be a power of two.
#define MAX         128

// begin.structures ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,

typedef unsigned long   ulong;

struct LineDef {
    char*       oData;          // "o" for original
    ulong       oLen;
    char*       data;           // free()'d by destructor ONLY
    ulong       len;
    ulong       trueLen;        // (trueLen > oLen) ? data : oData;
};

class TextFile {

    private:

    ulong       accessMODE;     // null, read-only, write-only, r/w {0123}
    ulong       lineQTY;        // number of lines
    ulong       currentLINE;    // current line
    ulong       fileSIZE;       // useless information I don't need
    char        *origBUF;       // original buffer
    LineDef     *lineDefLUT;    // line info
    char        name[MAX];      // file name
    char        eolnStr[4];

    public:

    ulong       eolnTYPE;       // 0:UN*X; non-zero:DOS


    private:

    int loadOrigBUF
        (
        char *filename
        );

    void initLineDef
        ();

    void de
        ();


    public:

    ~TextFile();

    // (API) :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    TextFile
        ();

    int phresh
        (
        char *filename,
        ulong lines,
        ulong mode
        );

    int load
        (
        char *filename,
        ulong mode
        );

    int save
        ();

    int save
        (
        char *filename
        );

    int currentLine
        (
        char *dst,
        ulong max
        );

    int overwriteLine
        (
        char *src
        );

    int deleteLine
        ();

    ulong currentLineNUM
        ();

    ulong lastLineNUM
        ();

    int moveCursorABS
        (
        ulong x
        );

    int moveCursorREL
        (
        int x
        );

    int print
        (
        ulong a,
        ulong b,
        int skipEmpty
        );

};


// end.structures ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,


/*
    Dump the contents of the file into a char[].  The file is opened,
    read, and closed within this function.
    [modified]  fileSIZE, origBUF
    [allocated] origBUF
    [returns]
        0   : success
        1   : file could not be opened
        2   : insufficient memory
%% .......................................................................*/
int TextFile::loadOrigBUF
    (
    char *filename
    )
{
    FILE*   infile;
    ulong   u0;

    infile = fopen(filename,"rb");
    if (infile == NULL) {
        return(1);
    }
    fseek(infile,0,SEEK_END);
    u0 = ftell(infile);
    fileSIZE = u0;
    origBUF = (char *) malloc(u0 * sizeof(char));
    if (origBUF == NULL) {
        fclose(infile);
        return(2);
    }
    fseek(infile,0,SEEK_SET);
    fread(origBUF,sizeof(char),u0,infile);
    fclose(infile);
    return(0);
}


/*
    Most of the hard work happens here.
    [uses]      fileSIZE
    [modifies]  lineDefLUT, lineQTY, currentLINE, fileSIZE
    [allocates] lineDefLUT
%% .......................................................................*/
void TextFile::initLineDef
    ()
{
    ulong   u0,u1,u2,u3,u4;
    char    c0;

    // PASS 1 (count 0x0a) :::::::::::::::::::::::::::::::::::::::::::::::::

    u0 = 0;
    u1 = 0;
    while (u0 < fileSIZE) {
        c0 = origBUF[u0];
        u0++;
        if (c0 == 0x0a) u1++;
    }
    lineQTY = u1;
    lineDefLUT = (LineDef *) malloc((u1+1) * sizeof(LineDef));


    // PASS 2 (This one is always harder.) :::::::::::::::::::::::::::::::::

    /*
    ;   u0  :   origBUF index
    ;   u1  :   line counter
    ;   u2  :   trueLen holder
    ;   u3  :   (u0 - 1)
    ;   u4  :   (trueLen)
    */

    u0 = 0;
    u4 = 0;
    for (u1 = 1; u1 <= lineQTY; u1++) {
        lineDefLUT[u1].oData = &origBUF[u0];
        u2 = 1;
        c0 = origBUF[u0];
        while (c0 != 0x0a) {
            u0++;
            u2++;
            c0 = origBUF[u0];
        }
        u3 = u0 - 1;
        origBUF[u0] = 0;
        u2--;
        lineDefLUT[u1].data = NULL;
        lineDefLUT[u1].oLen = u2;
        if (origBUF[(u3)] == 0x0d) {
            origBUF[(u3)] = 0;
            u2--;
        }
        u0++;
        lineDefLUT[u1].len = 0;
        lineDefLUT[u1].trueLen = u2;
        u4 += u2;
    }

    u3 = lineQTY;
    if (eolnTYPE != EOLN_UNIX) {
        u3 += u3;
    }
    fileSIZE = u3 + u4;                 // I don't need fileSIZE !!!
}




/*
    Deallocate currently allocated memory.
%% .......................................................................*/
void TextFile::de
    ()
{
    ulong   u0;

    accessMODE = xx_ACCESS;
    lineQTY = 0;
    currentLINE = 0;
    name[0] = 0;

    #if 1
    if (lineDefLUT != NULL) {
        for (u0 = 1; u0 <= lineQTY; u0++) {
            if (lineDefLUT[u0].data != NULL) free(lineDefLUT[u0].data);
        }
        free(lineDefLUT);
    }
 
    if (origBUF != NULL) {
        free(origBUF);
    }
    #endif
}




// :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::. PUBLIC .::




/*
    Destructor
%% .......................................................................*/
TextFile::~TextFile
    ()
{
    #if NotSilent
    printf("Destructor\n");
    #endif

    de();
}



/*
    Constructor
%% .......................................................................*/
TextFile::TextFile
    ()
{
    #if NotSilent
    printf("Constructor (default)\n");
    #endif

    #if 1
    origBUF = NULL;
    lineDefLUT = NULL;
    eolnTYPE = EOLN_UNIX;
    accessMODE = xx_ACCESS;
    currentLINE = 0;
    lineQTY = 0;
    name[0] = 0;
    eolnStr[0] = 0x0d;
    eolnStr[1] = 0x0a;
    eolnStr[2] = 0x00;
    eolnStr[3] = 0x00;
    #endif
}



/*
    [returns]
        0 : success
        n : failure
%% .......................................................................*/
int TextFile::phresh
    (
    char *filename,
    ulong lines,
    ulong mode
    )
{
    de();
    mode &= 0x03;
    if (mode == xx_ACCESS) return(1);
    accessMODE = mode;
    eolnTYPE = EOLN_UNIX;

    ulong   u0,u1,u2;

    // copy filename

    u0 = strlen(filename);
    u1 = MAX - 2;
    if (u0 < u1) u1 = u0;
    memcpy(name,filename,u1);
    name[u1] = 0;

    // allocate original buffer

    u0 = sizeof(char) * ALLOC_STEP * 4;
    origBUF = (char *) malloc(u0 * lines);
    if (origBUF == NULL) return(2);

    // initialize lineDefLUT

    lineDefLUT = (LineDef *) malloc((lines+1) * sizeof(LineDef));
    if (origBUF == NULL) return(2);
    u2 = 0;
    for (u1 = 1; u1 <= lines; u1++) {
        lineDefLUT[u1].oData = &origBUF[u2];
        lineDefLUT[u1].oLen = u0;
        lineDefLUT[u1].data = NULL;
        lineDefLUT[u1].len = 0;
        lineDefLUT[u1].trueLen = 0;
        origBUF[u2] = 0;
        u2 += u0;
    }
    lineQTY = lines;
    currentLINE = 1;
    return(0);
}



/*
    [returns]
        0 : success
        n : failure
%% .......................................................................*/
int TextFile::load
    (
    char *filename,
    ulong mode
    )
{
    ulong   u0,u1;

    de();
    if (accessMODE) return(1);
    mode &= 0x00000003;
    if (mode == xx_ACCESS) return(1);
    accessMODE = mode;

    u0 = strlen(filename);
    u1 = MAX - 2;
    if (u0 < u1) u1 = u0;
    memcpy(name,filename,u1);
    name[u1] = 0;

    u0 = loadOrigBUF(filename);
    if (u0) return(u0);
    initLineDef();
    currentLINE = 1;
    return(0);
}



/*
    Dumps TextFile into file.
    [returns]
        0 : success
        n : failure
%% .......................................................................*/
int TextFile::save
    ()
{
    FILE*   outfile;
    char    *eoLn;

    if ((accessMODE == xx_ACCESS) ||
        (accessMODE == Rx_ACCESS)) return(1);

    outfile = fopen(name,"wb");
    if (outfile == NULL) return(1);
    eoLn = (eolnTYPE == EOLN_DOS) ? eolnStr : (eolnStr + 1);

    ulong   u0,u1,u2;
    char    *src;

    for (u0 = 1; u0 <= lineQTY; u0++) {
        u1 = lineDefLUT[u0].trueLen;
        u2 = lineDefLUT[u0].oLen;
        src = (u1 > u2) ? lineDefLUT[u0].data : lineDefLUT[u0].oData;
        fprintf(outfile,"%s%s",src,eoLn);
    }
    fclose(outfile);
    return(0);
}




/*
    Dumps TextFile into file of specified name.
    [returns]
        0 : success
        n : failure
%% .......................................................................*/
int TextFile::save
    (
    char *filename
    )
{
    FILE*   outfile;
    char    *eoLn;

    if ((accessMODE == xx_ACCESS) ||
        (accessMODE == Rx_ACCESS)) return(1);

    outfile = fopen(filename,"wb");
    if (outfile == NULL) return(1);
    eoLn = (eolnTYPE == EOLN_DOS) ? eolnStr : (eolnStr + 1);

    ulong   u0,u1,u2;
    char    *src;

    for (u0 = 1; u0 <= lineQTY; u0++) {
        u1 = lineDefLUT[u0].trueLen;
        u2 = lineDefLUT[u0].oLen;
        src = (u1 > u2) ? lineDefLUT[u0].data : lineDefLUT[u0].oData;
        fprintf(outfile,"%s%s",src,eoLn);
    }
    fclose(outfile);
    return(0);
}



/*
    The contents of the current line will be copied into dst[]
    if src[] is not too long.
    [returns]
        0 : success
        1 : failure
%% .......................................................................*/
int TextFile::currentLine
    (
    char *dst,
    ulong max
    )
{
    ulong   u0,u1,u2;
    char    *src;

    if ((accessMODE & 0x01) == 0) return(1);

    u1 = currentLINE;
    u0 = lineDefLUT[u1].trueLen;
    u2 = lineDefLUT[u1].oLen;
    if (u0 != 0) {
        src = (u0 > u2) ? lineDefLUT[u1].data : lineDefLUT[u1].oData;
        if (u0 >= max) u0 = (max - 1);
        memcpy(dst,src,u0);
    }
    dst[u0] = 0;
    return(0);
}


/*
    This will place the ASCIIZ string in src[] into the current line
    [returns]
        0 : success
        1 : memory could not be allocated
%% .......................................................................*/
int TextFile::overwriteLine
    (
    char *src
    )
{
    ulong   u0,u1,u2,u3;

    if ((accessMODE == xx_ACCESS) ||
        (accessMODE == Rx_ACCESS)) return(1);

    u2 = currentLINE;
    u3 = strlen(src);
    if (u3 <= lineDefLUT[u2].oLen) {
        lineDefLUT[u2].trueLen = u3;
        memcpy(lineDefLUT[u2].oData,src,u3);
        lineDefLUT[u2].oData[u3] = 0;
        return(0);
    }
    else {
        if (lineDefLUT[u2].len >= u3) {
            lineDefLUT[u2].trueLen = u3;
            memcpy(lineDefLUT[u2].data,src,u3);
            lineDefLUT[u2].data[u3] = 0;
            return(0);
        }
        else {
            char *adr0 = lineDefLUT[u2].data;
            u1 = u3;
            u0 = (ulong) -ALLOC_STEP;
            u1 &= u0;
            u1 += ALLOC_STEP;
            adr0 = (char *) realloc(adr0,u1 * sizeof(char));
            if (adr0 == NULL) {
                return(1);
            }
            lineDefLUT[u2].data = adr0;
            lineDefLUT[u2].len = u1;
            lineDefLUT[u2].trueLen = u3;
            memcpy(lineDefLUT[u2].data,src,u3);
            lineDefLUT[u2].data[u3] = 0;
            return(0);
        }
    }
}



/*
    This will delete the current line.
    [returns]   previous length
%% .......................................................................*/
int TextFile::deleteLine
    ()
{
    if ((accessMODE == xx_ACCESS) ||
        (accessMODE == Rx_ACCESS)) return(0);

    ulong u0;
    u0 = lineDefLUT[currentLINE].trueLen;
    lineDefLUT[currentLINE].oData[0] = 0;
    lineDefLUT[currentLINE].trueLen = 0;
    return(u0);
}



/*
    [returns]   currentLINE
%% .......................................................................*/
ulong TextFile::currentLineNUM
    ()
{
    return(currentLINE);
}


/*
    [returns]   lineQTY
%% .......................................................................*/
ulong TextFile::lastLineNUM
    ()
{
    return(lineQTY);
}



/*
    Move the cursor to the line requested.  Valid lines range from
    1..lineQTY.
    [requirement] accessMODE > 0
    [returns]
        accessMODE == 0     :   0
        invalid line        :   lineQTY (aka last valid line)
        valid line          :   line requested
%% .......................................................................*/
int TextFile::moveCursorABS
    (
    ulong x
    )
{
    if (accessMODE) {
        if (x > lineQTY) {
            return(lineQTY);
        }
        currentLINE = x;
        return(x);
    }
    else {
        return(0);
    }
}


/*
    Move the cursor from currentLINE to (currentLINE + x) where x is
    a signed integer.
    [requirement] accessMODE > 0
    [returns]
        accessMODE == 0     :   0
        invalid line        :   lineQTY (aka last valid line)
        valid line          :   new currentLINE
%% .......................................................................*/
int TextFile::moveCursorREL
    (
    int x
    )
{
    ulong u0;

    if (accessMODE) {
        u0 = currentLINE + x;
        if (u0 > lineQTY) {
            return(lineQTY);
        }
        currentLINE = u0;
        return(u0);
    }
    else {
        return(0);
    }
}


/*
    To stdout, the specified contents of TextFile will be dumped.
    Please let (a <= b).
    [returns]
        0 : success
        1 : failure
%% .......................................................................*/
int TextFile::print
    (
    ulong a,
    ulong b,
    int skipEmpty
    )
{
    if ((accessMODE & 0x01) == 0) return(1);
    if ((b > lineQTY) || (a > b)) return(1);

    ulong   u0,u1,u2;
    char    *src;

    for (u0 = a; u0 < b; u0++) {
        u1 = lineDefLUT[u0].trueLen;
        u2 = lineDefLUT[u0].oLen;
        src = (u1 > u2) ? lineDefLUT[u0].data : lineDefLUT[u0].oData;
        if (u1 != 0) {
            printf("%s\n",src);
        }
        else {
            if (skipEmpty == 0) {
                printf("\n");
            }
        }
    }
    return(0);
}
